// --- [ global.h ] -----------------------------------------------------------
//
// tab = 3
// ----------------------------------------------------------------------------

#ifndef EXTERN
#define EXTERN extern
#endif

//#define NO_OVERWRITE							// innerhalb einer Session drfen
														// neu angelegte Daten nicht berschrieben werden
														// Begrenzung auf 4096 Pages
//#define NO_OVERRUN								// Ist das Ende des Speichers erreicht, dann wird das
														// Loggen beendet, der Index luft nicht auf 0 ber.
														// Wieviele Pages geloggt werden hngt somit davon ab,
														// wie voll der Speicher bereits war.
														
#define 	DF_BUFFER_SIZE  		256			// Gre des Datenpuffers
#define  DF_HEADER_SIZE			8				// plus Header = 264 Byte

#define  LED1						PD2
#define  LED2						PD3
#define  LED3						PD4
#define  LED_PORT					PORTD
#define  LED_DDR					DDRD

#define  LED1_OFF					LED_PORT &= ~(1<<LED1)
#define  LED1_ON					LED_PORT |=  (1<<LED1)
#define  LED1_TOG					LED_PORT ^=  (1<<LED1)

#define  LED2_OFF					LED_PORT &= ~(1<<LED2)
#define  LED2_ON					LED_PORT |=  (1<<LED2)
#define  LED2_TOG					LED_PORT ^=  (1<<LED2)

#define  LED3_OFF					LED_PORT &= ~(1<<LED3)
#define  LED3_ON					LED_PORT |=  (1<<LED3)
#define  LED3_TOG					LED_PORT ^=  (1<<LED3)

#define  KEY_PIN					PIND
#define  KEY_PORT					PORTD
#define	KEY_START				PD6
#define  KEY_PLAY					PD7

#define	KEY_START_PRESSED		(!(KEY_PIN & (1<<KEY_START)))
#define  KEY_START_RELEASED	(KEY_PIN & (1<<KEY_START))

#define	KEY_PLAY_PRESSED		(!(KEY_PIN & (1<<KEY_PLAY)))
#define  KEY_PLAY_RELEASED		(KEY_PIN & (1<<KEY_PLAY))

#define  TRUE						1
#define	FALSE						0

// --- globale Variablen ------------------------------------------------------

EXTERN volatile uint8_t LED_timeout;		// Zhler fr Warteschleifen (33 ms Takt)

EXTERN			 uint16_t file_id;			// eindeutige Kennung fr alle Pages einer Datei
EXTERN          uint16_t file_page_cnt;	// fortlaufende Nummerierung der Pages einer Datei
EXTERN			 uint8_t  file_page_size;	// Anzahl der Bytes in einer Page
EXTERN			 uint16_t session_pages;	// Anzahl der in dieser Sitzung geschriebenen Pages

EXTERN volatile uint8_t bytes_received;	// Zhler fr die Anzahl der empfangenen Bytes
EXTERN volatile uint16_t df_next_page;		// Zeiger auf die nchste freie Page

EXTERN uint8_t  rx_buffer[2][DF_BUFFER_SIZE];// doppelter Empfangspuffer
EXTERN volatile uint8_t  rx_idx;				// Pointer auf das nchste Byte im Empfangspuffer
EXTERN volatile uint8_t rx_buffer_ptr;		// Pointer auf einen der beiden rx_buffer
EXTERN volatile uint8_t rx_flag;				// signalisiert den Empfang eines kompletten Buffers

EXTERN uint8_t  df_header[8];

EXTERN uint8_t  df_buffer[DF_BUFFER_SIZE];// interner Puffer zum Einlesen einer Page aus dem DF 

EXTERN char msg[11];								// zur Umwandlung von Zahlen in Ziffernfolgen

EXTERN			uint16_t time;					// 2 Byte Sekundenzhler

// --- [ eof ] ----------------------------------------------------------------
